
#ifndef KDIST_H
#define KDIST_H

#include "equivalence.h"

typedef struct DistEntry_s DistEntry;
typedef struct HashSlot_s HashSlot;
typedef struct DistSlot_s DistSlot;

struct DistEntry_s
{
	float dist;

	equivalenceTuple *eqTuple1;
	equivalenceTuple *eqTuple2;

	HashSlot *hashSlot;
	int hashSlotNo;

	DistSlot *distSlot;
	int distSlotNo;
};

struct HashSlot_s
{
	DistEntry **entry;

	int noOfEntry;
};

struct Hash_s
{
	HashSlot *slot;
	int noOfSlot;
};

typedef struct Hash_s Hash;

struct DistSlot_s
{
	DistEntry **entry;

	int noOfEntry;
};

struct DistStorage_s
{
	DistSlot *slot;

	int noOfSlot;
	float delta;
};

typedef struct DistStorage_s DistStorage;

/*

struct AttributeList_s
{
	int noOfAttr;

	int *attr;
};

typedef struct AttributeList_s AttributeList;
*/

Hash *hash_new(int noOfSlot);
void kDist_insertDistEntry2Hash(Hash *hash, DistEntry **distEntryP);

void kDist_removeDistEntryFromHashSlot(DistEntry *distEntry);

DistStorage *distStorage_new(float delta, float maxValue);
DistSlot *distSlot_new();
void kDist_insertDistEntry2DistStorage(DistStorage *distStorage, DistEntry **distEntryP);

void kDist_removeDistEntryFromDistSlot(DistEntry *distEntry);

void kDist_moveSatisfiedEqClass(equivalenceClass *proEqClass, equivalenceClass *finalEqClass, int K);
void kDist_calculatePairDistanceWithSuppression(Hash *hash, DistStorage *distStorage, equivalenceClass *finalEqClass, equivalenceClass *proEqClass, generalizedAllTable *genAllTable, configure *conf);

void kDist_suppressIteration(Hash *hash, DistStorage *distStorage, equivalenceClass *proEqClass, equivalenceClass *finalEqClass, configure *conf, generalizedAllTable *genAllTable);
void kDist_findMinDistForGeneralization(DistStorage *distStorage, Hash *hash, generalizedAllTable *genAllTable, configure *conf, equivalenceClass *proEqClass, equivalenceClass *finalEqClass);
void kDist_suppressBatch(Hash *hash, DistStorage *distStorage, int id, equivalenceClass *finalEqClass, equivalenceClass *proEqClass, generalizedAllTable *genAllTable, configure *conf);
void printDistStorage(FILE *filePtr, DistStorage *distStorage);

void kDist_randomGeneralization(generalizedAllTable *genAllTable, configure *conf, equivalenceClass *proEqClass, equivalenceClass *finalEqClass);
void kDist_suppressBatchRandom(int id, equivalenceClass *finalEqClass, equivalenceClass *proEqClass, generalizedAllTable *genAllTable, configure *conf);

extern void generalizeEquivalenceTuple(equivalenceTuple *eqTuple, int attrNo, generalizedLevelTable *genLevelTable);;

#endif

